



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>django ORM常用查询条件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">django ORM常用查询条件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 15:12:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>假设有一个模型</p>
<div>
<pre class="prettyprint linenums">class Article(models.Model):<br />
    title=models.CharField(max_length=50)<br />
    content=models.TextField()<br />
    class Meta:<br />
        db_table='book'</pre>
</div>
<p>对于查询结果是结果集，即通过filter进行查询所得的对象来说，可通过query属性来查看django转换之后的原生sql语句</p>
<div>
<pre class="prettyprint linenums">&hellip;&hellip;<br />
article=Article.objects.filter(title='Hello World')<br />
    print(<strong>article.query</strong>)<br />
    print(article)<br />
&hellip;&hellip;</pre>
</div>
<p>查询结果为</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1491217/201812/1491217-20181223175452644-580299955.png" /></p>
<p>exact：即相当于数据库底层的等号=</p>
<p>article=Article.objects.filter(title__exact='Hello World')，即相当于数据库底层的select &middot;&middot;&middot; from &middot;&middot;&middot; where title='Hello World'</p>
<p>iexact：即相当于数据库底层的like</p>
<p>article=Article.objects.filter(title__iexact='Hello World')，即相当于数据库底层的select &middot;&middot;&middot; from &middot;&middot;&middot; where title like 'Hello World'</p>
<p>contains：大小写敏感的匹配查询，也是like，注意转换后查询条件的两侧都有%</p>
<p>article=Article.objects.filter(title__contains='Hello World')，即相当于数据库底层的select &middot;&middot;&middot; from &middot;&middot;&middot; where title like '%Hello World%'</p>
<p>icontains：大小写不敏感的匹配查询</p>
<p>article=Article.objects.filter(title__icontains='Hello World')，即相当于数据库底层的select &middot;&middot;&middot; from &middot;&middot;&middot; where title like '%Hello World%'</p>
<p>in：查询条件是否在给定的范围内，用小括号和中括号都可以</p>
<p>article=Article.objects.filter(id__in=(1,2,6,9))，即相当于数据库底层的select &middot;&middot;&middot; from &middot;&middot;&middot; where id in (1,2,6,9)</p>
<p>gt：大于</p>
<p>gte：大于等于</p>
<p>lt：小于</p>
<p>lte：小于等于</p>
<p>article=Article.objects.filter(id__gt=5)，即相当于数据库底层的select &middot;&middot;&middot; from &middot;&middot;&middot; where id &gt; 5</p>
<p>startswith：以指定某个字符串开始，大小写敏感</p>
<p>istartswith：以指定某个字符串开始，大小写不敏感</p>
<p>endswith：以指定某个字符串结束，大小写敏感</p>
<p>iendswith：以指定某个字符串结束，大小写不敏感</p>
<p>article=Article.objects.filter(title__startswith='Hello')，即相当于数据库底层的select &middot;&middot;&middot; from &middot;&middot;&middot; where title like 'Hello%'</p>
<p>article=Article.objects.filter(title__endswith='Hello')，即相当于数据库底层的select &middot;&middot;&middot; from &middot;&middot;&middot; where title like %'Hello'</p>
<p>range：在某个范围，即相当于between &middot;&middot;&middot; and &middot;&middot;&middot;，用小括号和中括号都可以</p>
<p>article=Article.objects.filter(id__range=(1,6))，即相当于select &middot;&middot;&middot; from &middot;&middot;&middot; where id between 1 and 6</p>
<p>isnull：是否为空</p>
<p>article=Article.objects.filter(content__isnull=False)，即相当于select &middot;&middot;&middot; from &middot;&middot;&middot; where content is not null</p>
<p>exclude：排除满足条件的</p>
<p>article=Article.objects.exclude(content=False)</p>
<p>order_by 按指定字段正向排序</p>
<p>article=Article.objects.all().order_by('title')</p>
<p>reverse：反向排序</p>
<p>distinct：去重</p>
<p>article=Article.objects.all().values('title').distinct()</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j0xv4q.html">Android工程的编译过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqljwve9.html">FOJ 2181 快来买肉松饼</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql1j7x9.html">JQ中的方法、事件及动画</a>
		</li>
						<li><a href="https://www.batexi.com/a/390p5zo8.html">扩展JQuery和JS的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq127e49.html">git的基本操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1gyek8.html">Sql Server Profiler跟踪死锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m23ngq.html">Unity3D设置字体颜色大小&comma;用于游戏分数显示设置等，</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w66kwq.html">C 中随机数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk6ned8.html">BotVS开发基础&mdash;2&period;2 下限价单 交易</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jgjgl8.html">latex插图续</a>
		</li>
						<li><a href="https://www.batexi.com/a/950en368.html">vue &plus; element &plus; 初始化项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wppgrq.html">Git&amp;&num;160&semi;结合Git使用Bitbucket进行代码版本管理流程规范与实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv20k7z9.html">浅析PHP中的闭包和匿名函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rkdp39.html">springboot &commat;scheduled 并发</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r1ezj9.html">用idea搭建SSM项目，原来这么简单</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r2rw48.html">NPOI DataSet导出excel</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w17nrq.html">CH 2601 - 电路维修 - &lbrack;双端队列BFS&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g40zvq.html">【转】UGUI研究院之缓存策略让UI打开更快（三十）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5ep4eq.html">今天清理C盘空间，发现Unity的一个问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k020wq.html">Wii Party U 游戏简介</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90r5o339.html">背景图宽高100&percnt;无法无法显示的问题【body设置relative，当前元素absolute】</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjynr49.html">js计算最大公约数和最小公倍数</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g151eq.html">分享一个&period;NET&lpar;C&num;&rpar;按指定字母个数截断英文字符串的方法&ndash;提供枚举选项，可保留完整单词</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdmwkd9.html">mysql 延迟添加唯一索引</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o10n6pq.html">Jmeter获取响应结果中参数出现的次数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwodk78.html">8&period;一个页面从输入 URL 到页面加载显示完成，这个过程中都发生了什么？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdmdjj9.html">java&period;lang&period;NoClassDefFoundError&colon; org&sol;hibernate&sol;QueryTimeoutException</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll31nxq.html">JS实例4</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll31req.html">并发工具CyclicBarrier</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjgmj69.html">&lbrack;16&rsqb;Windows内核情景分析 --- 服务管理</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
